<CsoundSynthesizer>

<CsOptions>
-W -o For_FTS_x^n_-_x.wav 
</CsOptions>

<CsScore>


;; test harmonic series to play if user compiles this instrument directly to an audio file in csound
i1 	0 	2 	3277 	 	46.249303 	 	7 	 	10 	 	50 	
i1 	0.5 	2 	3277 	 	92.498606 	 	7 	 	10 	 	50 	
i1 	1 	2 	3277 	 	138.747909 	 	7 	 	10 	 	50 	
i1 	1.5 	2 	3277 	 	184.997211 	 	7 	 	10 	 	50 	
i1 	2 	2 	3277 	 	231.246514 	 	7 	 	10 	 	50 	
i1 	2.5 	2 	3277 	 	277.495817 	 	7 	 	10 	 	50 	
i1 	3 	2 	3277 	 	323.74512 	 	7 	 	10 	 	50 	
i1 	3.5 	2 	3277 	 	369.994423 	 	7 	 	10 	 	50 	
i1 	4 	2 	3277 	 	416.243726 	 	7 	 	10 	 	50 	
i1 	4.5 	2 	3277 	 	462.493028 	 	7 	 	10 	 	50 	
i1 	5 	2 	3277 	 	508.742331 	 	7 	 	10 	 	50 	
i1 	5.5 	2 	3277 	 	554.991634 	 	7 	 	10 	 	50 	
i1 	6 	2 	3277 	 	601.240937 	 	7 	 	10 	 	50 	
i1 	6.5 	2 	3277 	 	647.49024 	 	7 	 	10 	 	50 	
i1 	7 	2 	3277 	 	693.739543 	 	7 	 	10 	 	50 	
i1 	7.5 	2 	3277 	 	739.988845 	 	7 	 	10 	 	50 	
i1 	8 	2 	3277 	 	786.238148 	 	7 	 	10 	 	50 	
i1 	8.5 	2 	3277 	 	832.487451 	 	7 	 	10 	 	50 	
i1 	9 	2 	3277 	 	878.736754 	 	7 	 	10 	 	50 	
i1 	9.5 	2 	3277 	 	924.986057 	 	7 	 	10 	 	50 	
i1 	10 	2 	3277 	 	971.23536 	 	7 	 	10 	 	50 	
i1 	10.5 	1.5 	3277 	 	1017.484662 	 	7 	 	10 	 	50 	
i1 	11 	1 	3277 	 	1063.733965 	 	7 	 	10 	 	50 	
i1 	11.5 	0.5 	3277 	 	1109.983268 	 	7 	 	10 	 	50 	
;; Since it is played using the instrument number set in the CsInstrumentToPlay section, an auto score building program
;; can recognise these as test notes, rather than initialisation type notes, and leave them out
;
</CsScore>

<CsInstrumentToPlay>
i1 AMP CPS 7 0.1 50.0 ; n - must be odd, rise in seconds, decay percentage
</CsInstrumentToPlay>

<CsGlobals>
 
ksmps = 1 ; Set the control rate to the audio rate. Modern computers are fast enough to control at audio rate
; This is needed to generate the sine curve at audio rate directly. When this instrument is used
; all the instruments in the orchestra will control at audio rate. Preset is 1/10th of audio rate.
</CsGlobals>

<CsPitchBendGlides>
* ; Add an * here to show that it responds to pitch bend glides when auto converted into a midi instrument for CSoundAV (can be done
in Fractal Tune Smitny)
</CsPitchBendGlides>

<CsInstruments>
instr 1

; args: AMP CPS 10.0 50.0 ; rise proportion (as percentage of total duration), decay proportion,

iduration  = p3
iamplitude  = p4
kcsav_cps = p5

;This; enables pitch glides for FTS orchestra building for CSoundAV
kp5 = p5
kfrequency  = kp5
ifrequency  = p5

ipower = p6
irise= p7
idecaypercent = p8

asamples init 0
atime=asamples/sr
asamples = asamples+1

idecay = iduration*idecaypercent/100
kenv linen iamplitude, irise, iduration, idecay

apos=(kfrequency*atime)%1.0 ; range 0 to 1

ax=apos*2-1; range -1 to 1

a1 =kenv * (ax^ipower - ax)

; x^n - x^m has max value at nx^n-1 == mx^m-1
; so at x^(n-m) = m/n
; and value is
; (m/n - 1) * (m/n)^ (m/(n-m))

imm = ipower
inn = 1
imult = (imm/inn - 1) * exp( (imm/(inn - imm) ) * log(imm/inn) )

   out a1*1/imult
endin
</CsInstruments>

</CsoundSynthesizer>
